Skip to content
Snippets Groups Projects
foamPackSource 2.41 KiB
Newer Older
#!/bin/sh
#------------------------------------------------------------------------------
# =========                 |
# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
#  \\    /   O peration     |
#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
#    \\/     M anipulation  |
#-------------------------------------------------------------------------------
# License
#     This file is part of OpenFOAM.
#
#     OpenFOAM is free software: you can redistribute it and/or modify it
#     under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#     for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
#
# Script
#     foamPackSource <directory> <tarFile>
#
# Description
#     Packs and compresses the .C and .H files and Make/options
#     and Make/files in a given directory.
#
#------------------------------------------------------------------------------
tmpFile=${TMPDIR:-/tmp}/foamPackFiles.$$

if [ $# -ne 2 ]
then
Mark Olesen's avatar
Mark Olesen committed
    echo "Usage : ${0##*/} directory tarFile"
    echo ""
    echo "Packs all .C and .H files and Make/options and Make/files into"
    echo "<tarFile>"
    echo ""
    exit 1
fi

# canonical form (no double and no trailing dashes)
packDir=$(echo "$1" | sed -e 's@//*@/@g' -e 's@/$@@')
packFile=$2

if [ ! -d $packDir ]
then
Mark Olesen's avatar
Mark Olesen committed
    echo "Error: directory $packDir does not exist"
    exit 1
if [ -f $packFile ]
then
Mark Olesen's avatar
Mark Olesen committed
    echo "Error: $packFile already exists"
    exit 1
fi

# Clean up on termination and on Ctrl-C
trap 'rm -f $tmpFile 2>/dev/null; exit 0' EXIT TERM INT

foamSourceFiles $packDir > $tmpFile
Mark Olesen's avatar
Mark Olesen committed

# provide some feedback
wc $tmpFile | awk '{print "Packing",$1,"files - this could take some time ..."}'

tar czpf $packFile --files-from $tmpFile

Mark Olesen's avatar
Mark Olesen committed
if [ $? -eq 0 ]
Mark Olesen's avatar
Mark Olesen committed
    echo "Finished packing and compressing $packDir into file $packFile"
Mark Olesen's avatar
Mark Olesen committed
    echo "Error: failure packing $packDir into file $packFile"
    rm -f $packFile 2>/dev/null
fi

#------------------------------------------------------------------------------